
Figure - Bug #118522
【IOVDEV-32656】【IOV测试】【VC1】【SORP】【副屏】【实车306】副屏播放QQ音乐，切换到副屏腾讯
视频，音乐视频混音
2023-06-05 15:32 - CDTS_Test 吴诗雨

Status: CLOSED Start date: 2023-06-05

Priority: High Due date:

Assignee: CD TEST-方永红 % Done: 0%

Category: AUDIO-FW Estimated time: 0.00 hour

Target version:

Need_Info: -- Found Version: IDCM版本号:     03.02.0088.C103����副屏：0106

Resolution: FIXED Degrated: --

Severity: Major Verified Version:

Reproducibility: Every time Fixed Version:

Test Type: ST Root cause: 将AUDIOFOCUS_REQUEST_DELAYED获取焦点的应用做特殊判断，不主动更新焦点。

Description

【前提条件】：

车机上电、网络状态良好、时间显示正确、 账号登录正确

【操作步骤】：

1、副屏播放QQ音乐歌曲，允许于其他应用同时播放关闭

2、副屏切换到腾讯视频

【实际结果】：

1、视频和音乐混音

【期望结果】：

1、播放视频时，音乐暂停

【研发解决问题依赖】：

1、问题发生环境：EE

2、车机VIN号:LJD8BC3F1P0000306

3、bug时间：2023/6/5    1459

【备注】：

【软件版本号】：

IDCM版本号:     03.02.0088.C103

副屏：0106

History

#1 - 2023-06-05 18:00 - Multimedia组-RD3_TSCD 梁卿山

- Status changed from New to NEED_INFO

- Assignee changed from Multimedia组-RD3_TSCD 梁卿山 to CDTS_Test 吴诗雨

Hi 诗雨

根据日志分析：

在出现混音的时间段内，没有任何焦点申请的日志出现。

请获取云端日志，再详细分析，谢谢！
#2 - 2023-06-05 19:39 - CD TEST-方永红

- File 1685935652715.zip added

- Status changed from NEED_INFO to ASSIGNED

- Assignee changed from CDTS_Test 吴诗雨 to Multimedia组-RD3_TSCD 梁卿山

#3 - 2023-06-06 13:53 - CDTS_Test 吴诗雨

- File deleted (1685935652715.zip)

#4 - 2023-06-06 13:53 - CDTS_Test 吴诗雨

- File 1686030726599.zip added

#5 - 2023-06-06 16:24 - Multimedia组-RD3_TSCD 梁卿山

HI ALL

当前分析：

该问题直接原因是，腾讯视频播放时，没有再次申请焦点就播放，导致了混音。

我对比了蓝牙连接时的现象，发现正常，日志对比发现，腾讯视频没有重新申请焦点。

正常：

06-06 14:56:39.895 19679 20087 W AudioManager: See the documentation of requestAudioFocus() for what to use instead with android.media.AudioAttributes to

qualify your playback use case

06-06 14:56:39.897  1649  9931 I MediaFocusControl: requestAudioFocus() from uid/pid 10238/19679 AA=USAGE_MEDIA/CONTENT_TYPE_MUSIC

clientId=android.media.AudioManager@d461456com.tencent.qqmusicplayerprocess.servicenew.listener.AudioFocusListener$a@18d0cd7

callingPack=com.tencent.qqmusic req=1 flags=0x0 sdk=29

06-06 14:56:39.898  1649  9931 I MediaFocusControl: AudioFocus  removeFocusStackEntry(): removing entry for

android.media.AudioManager@d461456com.tencent.qqmusicplayerprocess.servicenew.listener.AudioFocusListener$a@18d0cd7

06-06 14:56:39.916  1649  9931 I MediaFocusControl: abandonAudioFocus() from uid/pid 10229/16054

clientId=android.media.AudioManager@b1fbce2com.tencent.qqlive.modules.vb.qmtpluginkit.impl.plugin.audiofocus.d@dc7873

06-06 14:56:40.007   938 23689 D audio_hw_primary: select_devices for use case (deep-buffer-playback)

06-06 14:56:40.009   938 23689 D audio_hw_primary: enable_snd_device: snd_device(2: speaker)

06-06 14:56:40.012   938 23689 E audio_hw_awinic_feedback: audio_extn_aw882xx_start_feedback: befor enable_snd_device

06-06 14:56:40.012   938 23689 D audio_hw_primary: enable_snd_device: snd_device(208: vi-feedback)

06-06 14:56:40.013   938 23689 E audio_hw_awinic_feedback: audio_extn_aw882xx_start_feedback: after enable_snd_device

06-06 14:56:58.865  1649  1755 D AS.AudioService: Volume controller visible: false

06-06 14:57:00.709 16054 19073 W AudioManager: See the documentation of requestAudioFocus() for what to use instead with android.media.AudioAttributes to

qualify your playback use case

腾讯视频重新申请焦点

06-06 14:57:00.712  1649  4409 I MediaFocusControl: requestAudioFocus() from uid/pid 10229/16054 AA=USAGE_MEDIA/CONTENT_TYPE_MUSIC

clientId=android.media.AudioManager@b1fbce2com.tencent.qqlive.modules.vb.qmtpluginkit.impl.plugin.audiofocus.d@dc7873 callingPack=com.tencent.qqlive

req=2 flags=0x0 sdk=31

异常

06-06 16:19:36.946  5543  6236 W AudioManager: See the documentation of requestAudioFocus() for what to use instead with android.media.AudioAttributes to

qualify your playback use case

06-06 16:19:36.948  1073  2156 I MediaFocusControl: requestAudioFocus() from uid/pid 10108/5543 AA=USAGE_MEDIA/CONTENT_TYPE_MUSIC
clientId=android.media.AudioManager@ec71e93com.tencent.qqmusicplayerprocess.servicenew.listener.AudioFocusListener$a@ecafed0

callingPack=com.tencent.qqmusic req=1 flags=0x0 sdk=29

06-06 16:19:36.949  1073  2156 I MediaFocusControl: AudioFocus  removeFocusStackEntry(): removing entry for

android.media.AudioManager@ec71e93com.tencent.qqmusicplayerprocess.servicenew.listener.AudioFocusListener$a@ecafed0

06-06 16:19:36.957  1073  2156 I MediaFocusControl: abandonAudioFocus() from uid/pid 10103/7709

clientId=android.media.AudioManager@7c0432ecom.tencent.qqlive.modules.vb.qmtpluginkit.impl.plugin.audiofocus.d@a5a7617

06-06 16:19:36.965  1073  2156 D AudioService.PlaybackActivityMonitor: idcm_af:requestAudioFocusToIDCM: event=2(PLAYER_STATE_STARTED)apc

=AudioPlaybackConfiguration piid:327 deviceId:3 type:android.media.AudioTrack u/pid:10108/5543 state:paused attr:AudioAttributes: usage=USAGE_MEDIA

content=CONTENT_TYPE_MUSIC flags=0xA00 tags= bundle=null sessionId:265

06-06 16:19:36.966  1073  2156 D AudioIDCMicroNegotiator: idcm_af:requestIDCMicroAudioFocus,  streamtype = 3

06-06 16:19:36.966  1073  2156 D AudioIDCMicroNegotiator: idcm_af:requestIDCMicroAudioFocus: Already has a audioFocus AudioFocus_Media

06-06 16:19:36.966  1073  2156 D AudioIDCMicroNegotiator: idcm_af:updateAudioInfo

06-06 16:19:36.966  1073  2156 D AudioIDCMicroNegotiator: idcm_af:notifyFocusState -> notify

06-06 16:19:36.966  1073  1944 D AudioIDCMicroNegotiator: idcm_af:wait messsage done -> onAudioFocusRemoteChanged

06-06 16:19:36.966  1073  1944 D AudioService.PlaybackActivityMonitor: idcm_af:onAudioFocusRemoteChanged: 1 info= RequestInfosToIDCM{mPid=5543,

mUid=10108}

06-06 16:19:36.966  1073  1944 D AS.AudioService: idcm_af:onAudioFocusIDCMicroChanged: 1 info: RequestInfosToIDCM{mPid=5543, mUid=10108}

06-06 16:19:36.985  1073  1944 D MediaFocusControl: audio_idcm: updateCurrentAudioFocus: uid= 10108 fr = 10108 focusChange= 1

06-06 16:19:36.985  1073  1944 D TS >>>  :  fr ---> getGainRequest =1

06-06 16:19:36.985  1073  1944 D AudioIDCMicroNegotiator: idcm_af:wait messsage

腾讯视频直接播放了，没有申请焦点

06-06 16:19:40.890  1073  2521 D AudioService.PlaybackActivityMonitor: idcm_af:requestAudioFocusToIDCM: event=2(PLAYER_STATE_STARTED)apc

=AudioPlaybackConfiguration piid:335 deviceId:0 type:android.media.AudioTrack u/pid:10103/7709 state:paused attr:AudioAttributes: usage=USAGE_MEDIA

content=CONTENT_TYPE_MUSIC flags=0x800 tags= bundle=null sessionId:297

下一步：

调查为什么腾讯视频没有申请焦点。

#6 - 2023-06-06 17:41 - Multimedia组-RD3_TSCD 梁卿山

HI ALL

进一步分析发现：

腾讯视频请求焦点时，使用的是AUDIOFOCUS_REQUEST_DELAYED，

导致腾讯视频在请求焦点时延时获取，

而我们之前的焦点更新时，没有延时获取的机制，导致了焦点先更新，

这就导致应用本身没有去请求焦点，这时QQ音乐和腾讯视频都保持了焦点。

当前方案：

将AUDIOFOCUS_REQUEST_DELAYED获取焦点的应用做特殊判断，不主动更新焦点。

#7 - 2023-06-06 20:05 - IoT scm

Gerrit Merge Information：

ID Project Branch Uploader

205147 general/platform/frameworks/base Pre_figure_turbox-c2130c-la1.1-qssi12

-dev

tangyj0127@thundersoft.com
MM: Audio: Delayed focus request maskingDelayed focus request maskingTC-RID: 0301-0900116IssueID: TS-R-DF-118522Change-Id:

I7d813774d9b2cf945088ff0b5e612a685cd2651e

#8 - 2023-06-06 20:06 - Multimedia组-RD3_TSCD 梁卿山

- Status changed from ASSIGNED to RESOLVED

- Assignee changed from Multimedia组-RD3_TSCD 梁卿山 to CD TEST-方永红

- Resolution changed from -- to FIXED

- Root cause set to 将AUDIOFOCUS_REQUEST_DELAYED获取焦点的应用做特殊判断，不主动更新焦点。

HI 永红

该问题已经通过方案解决，请使用6月7日版本验证，谢谢！

#9 - 2023-06-08 15:09 - SZTS_TEST 邹涛

- Status changed from RESOLVED to VERIFIED

在FlatBuild_HH_MCE_FSE.M.D.user.01.00.C104.202306080125版本验证通过

#10 - 2023-06-25 15:24 - CD TEST-方永红

- Status changed from VERIFIED to CLOSED

Files

IOVDEV-32656.zip 3.58 MB 2023-06-05 CDTS_Test 吴诗雨

1686030726599.zip 5.98 MB 2023-06-06 CDTS_Test 吴诗雨
